#include "itext.h"
#include "xjp.h"

#include <sys/stat.h>
#include <iconv.h>

#define ITEXT_STR
#define ITEXT_BOUTYPE 

#include "itext_f2.h"


static void _k_in(ITEXTR_T **kh,ITEXTR_T **kt,ITEXTR_T *kc)
{
	ITEXTR_T *k;

	if( (k = (ITEXTR_T *)malloc(sizeof(ITEXTR_T))) == NULL) 
		return;

	k->c1 = 0; 
	k->c2 = 0; 
	k->kun = kc;

	if( *kt ){
		k->next = NULL; k->prev = *kt;
		(*kt)->next = (ITEXTR_T *)k; *kt = k;
	}else{
		k->next = NULL; k->prev = NULL;
		*kt = k; *kh = k;
	}

	return;
}
static int _func2_0(char *str0,char *str1,int len)
{
	int i,j;
        unsigned char *p,*p1;

        j = 0;
        for(i = 0; i < len; i++){
                p = (unsigned char *)str1 + i;
		if( *p == ' ' ) continue;

                if( *p == 0xa3 ){
                        p1 = p + 1;

                        if( (*p1 >= 0xb0 && *p1 < (0xb0+10))  ||

                            (*p1 >= 0xc1 && *p1 < (0xc1+26))  ||

                            (*p1 >= 0xe1 && *p1 < (0xe1+26))  ){

				*( str0 + j++ ) = *p1 - 128;
				i++;
			}

		}else if( *p == 0xa1 ){
                        p1 = p + 1;

                        if ( *p1 == 0xb2 ){ 
				*( str0 + j++ ) = *p1 - 83;
				i++;

                        }else if( *p1 == 0xa5 ){
                                *( str0 + j++ ) = *p1 - 119;
				i++;

                        }
                }else{
			*( str0 + j++ ) = *p;
		}

        }
        *( str0 + j ) = '\0';

        return 0;
}
static int _get_pict(char **s1,char *s0)
{
	struct stat sbuf;
	char dir[128];

	char *p,*p0,*p1,temp[128],temp1[128],temp2[128];
	int j = 0,len;

	if( s0 == NULL ) return -1;

	sprintf(dir,"%s/%s",XJP_HOME,OTHER_FILE_DIR);

	p = s0;	
	for(;;){
		if( (p0 = strstr(p,"")) == NULL ){
		       	break;
		}
		if( (p1 = strstr(p0,"")) == NULL ){
			break;
		}else{
			memset(temp,'\0',127);
			strncpy(temp,p0+2,p1 - p0 -2);
			len = strlen(temp);

			_func2_0(temp1,temp,len);

			sprintf(temp2,"%s%s",dir,temp1);
			if( stat(temp2,&sbuf) == 0 ){
				len = strlen(temp2);
				*s1 = (char *)malloc(len + 2);
				memset(*s1,0,len + 2);
				strcpy(*s1,temp2);
				j++;
			}
		}
		p = p1;
	}

	return j;
}
static int _check_jis_no(char *temp)
{
	unsigned char c1,c2;
	unsigned char *p,no[5];
	int i,flag,m;

	if(		strstr(temp,CHU_JI_STR1) != NULL	||
			strstr(temp,CHU_JI_STR4) != NULL	||
			strstr(temp,CHU_JI_STR5) != NULL		)

				return 1;

	if(	(strstr(temp,CHU_JI_STR0)) == NULL 	&&
		(strstr(temp,CHU_JI_STR2)) == NULL	&&
		(strstr(temp,CHU_JI_STR3)) == NULL 	){


		if((strstr(temp,CHU_TE_STR0)) == NULL		&&
		   (strstr(temp,CHU_TE_STR1)) == NULL		&&
		   (strstr(temp,CHU_SMALL_STR1)) == NULL	){ 

			return -1;
		}
	}
	p = (unsigned char *)temp;

	i = 0; flag = 0;
	while(1){
		if(*p == '\0') break;
		if(itextCheckEuc(p) == 0) continue;

		c1 = *p++;
		c2 = *p++;
		if(c1 == NOSTR){
		       if(c2 >= 0xb0 && c2 <= 0xb9){

			       no[i++] = c2 - 0x80;

		       }else{
			       i = 0;

		       }
		}else{
			if( c1 == CHU_JI_C1 && c2 == CHU_JI_C2 ) break;

		}
	}
	if(i == 0) return -3;

	no[i] = '\0';

	m = atoi((char *)no) + 1;

	return m;
}
static int _check_bouten_type(char *temp)
{
	int i;
	int max = sizeof(bouten_type) / sizeof(BOUTEN_T);

	for( i = 0; i < max; i++){

		if(strstr(temp,bouten_type[i].name) != NULL) 
				return i;

	}

	if(strstr(temp,CHU_BOUTEN_STR) != NULL) 
			return 0;


	fprintf(stderr,"Error: Check [%s] itext_f2.c\n",temp);

	return -1;
}
static int _check_bousen_type(char *temp)
{
	int i;
	int max = sizeof(bousen_type)/sizeof(BOUTEN_T);

	for( i=0; i<max; i++ ){

		if(strstr(temp,bousen_type[i].name) != NULL) 
				return i;

	}

	return -1; 
}
static int _line_serch(ITEXT_T *ch,ITEXTR_T *bt)
{
	ITEXT_T *ch1;
	ITEXTR_T *bt1;
	int m = 0;

	for( ch1 = ch,bt1 = bt;;ch1 = ch1->prev,bt1 = bt1->prev ){
		if( ch1 == NULL || bt1 == NULL) break;

 		if( ch1->c1 != bt1->c1 || ch1->c2 != bt1->c2 )  break;

			m++;
	}

	if( bt1 == NULL )
		return m;
	else
		return 0;	
}
static int _put_bousen_type(char *temp,ITEXT_T *it)
{
	ITEXT_T	*ch,*ch1;
	ITEXTR_T *bouten_head = NULL;
	ITEXTR_T *bouten_tail = NULL;
	ITEXTR_T *bt,*chu;
	int tors,btype,mno;
	int f,r,c;

	if(temp == NULL || it == NULL) return 0;

	if( strstr(temp,CHU_BOUTEN_STR) != NULL ){
			tors = 0;
			btype = _check_bouten_type(temp);

	}else if( strstr(temp,CHU_BOUSEN_STR) != NULL ){
			tors = 1;
			btype = _check_bousen_type(temp);

	}else{
			btype = -1;
	}

	if( btype == -1 ) return 0;


	f = r = c = 0;
	for( chu = it->chu_head; chu != NULL;chu = chu->next ){

		if( chu->c1 == AMARK ){

			if( chu->c2 == SKAGI ){
		       		f = 1;
				continue;
			}else if( chu->c2 == EKAGI ){
				break;

			}else if( chu->c2 == SRUBY ){
				if( f == 1 ){
					r = 1;
					continue;
				}
			}else if( chu->c2 == ERUBY ){
				if( f == 1 ){
					r = 0;
					continue;
				}
			}else if( chu->c2 == SCHUS ){
				if( f == 1 ){
					c = 1;
					continue;
				}
			}else if( chu->c2 == SCHUE ){
				if( f == 1 ){
					c = 0;
					continue;
				}
			}

		}

		if( f == 1 && r == 0 && c == 0){
		       	itextRubiDataInsert(&bouten_head,&bouten_tail,chu->c1,chu->c2);
		}

	}
	if(bouten_head == NULL) return 0;


	for( ch = it; ch != NULL; ch = ch->prev){
		for( bt = bouten_tail; bt != NULL; bt = bt->prev){

			if( ch->c1 == bt->c1 && ch->c2 == bt->c2 ){

					if( ( mno = _line_serch(ch,bt)) > 0) 
							goto M_OK;
			}
		}
	}

	itext_rubidata_free(bouten_head);

	return 0;

M_OK:

	ch1 = ch;
	while( mno-- ){

			if( tors )
				OnFlag(ch1->flag,_SEN);
			else
				OnFlag(ch1->flag,_TEN);

			if(btype > 15) btype = 15;
			SetFlag(ch1->flag,btype);

			ch1 = ch1->prev;
	}

	itext_rubidata_free(bouten_head);

	return 1;
}
static int _put_small_font(char *temp,ITEXT_T *it,int *small)
{
	int m;

	if(temp == NULL || it == NULL) return 0;


	if( Small_Start_Str(temp) ){

		if((m = _check_jis_no(temp) - 1) > 15) m = 15;

		OnFlag(it->flag,_SML);
		SetFlag1(it->flag,m);

		*small = m;

		return 1;
	}

	if( Small_End_Str0(temp) && Small_End_Str1(temp) ){

		if( *small ){

			*small = 0;
			return 1;
		}
	}

	return 0;
}
static int _put_position(	char *temp,
				ITEXT_T **ihead,
				ITEXT_T **itail,
				unsigned char *p	)
{
	int m,head_mark = 0;

	if(temp == NULL || ihead == NULL || itail == NULL || p == NULL) 
		return 0;

	if((*itail)->c1 == CHU_KEY_C1 && (*itail)->c2 == CHU_KEY_C2) 
		head_mark = 1;

	if( strstr(temp,CHU_SMALL_STR1) != NULL ){

		if((m = _check_jis_no(temp) - 1) > 15) m = 15;

		if(head_mark){

			OnFlag((*itail)->flag,_MID); 
			SetFlag((*itail)->flag,m);

			return 1;
		}
		return 0;
	}


	if( Jchu_Str(temp) ){

		if((m = _check_jis_no(temp)) > 15) m = 15;

		if(head_mark){

			OnFlag((*itail)->flag,_LST); 
			SetFlag((*itail)->flag,m);

			return 1;

		}else{

			if( !*(p + 1) ){

				OnFlag((*ihead)->flag,_LST); 
				SetFlag((*ihead)->flag,m);
				return 1;

			}else{
				p = itext_next(p,ihead,itail);

				OnFlag((*itail)->flag,_LST);
				SetFlag((*itail)->flag,m);

				return 1;

			}

		}
	}

	if( Tchu_Str(temp) ){

		if((m = _check_jis_no(temp)+1) > 15) m = 15;

		if(head_mark){

			OnFlag((*itail)->flag,_TOP); 
			SetFlag((*itail)->flag,m);

			return 1;

		}else{

			return 0;
		}
	}

	return 0;
}
static int _put_wchufont(char *tmp,ITEXT_T **ihead,ITEXT_T **itail)
{
	unsigned char c1,c2;
	int ej,ch,sm;

	if( (tmp == NULL) || (*ihead == NULL) | (*itail == NULL) ) 
		return 0;

	ej = ChFlag((*itail)->flag,_EJC) ? 1 : 0;
	ch = ChFlag((*itail)->flag,_CHU) ? 1 : 0;
	sm = ChFlag((*itail)->flag,_SML) ? 1 : 0;

	if( Wchu_Str(tmp) ){

		if( strstr(tmp,CHU_SMALL_STR0) != NULL){

			c1 = AMARK;
			c2 = WCHUS;
			itextDataInsert(ihead,itail,c1,c2,ej,ch,sm);

			return 1;
		}

		if( Small_End_Str0(tmp) ){

			c1 = AMARK;
			c2 = WCHUE;
			itextDataInsert(ihead,itail,c1,c2,ej,ch,sm);

			return 1;
		}
	}

	return 0;
}
int _check_rev(ITEXTR_T *it)
{
	if( it != NULL ){

		if(it->c1 == 0xa5 && it->c2 == 0xec) return 1;
		if(it->c1 == 0xb0 && it->c2 == 0xec) return 1;
		if(it->c1 == 0xc6 && it->c2 == 0xf3) return 1;
		if(it->c1 == 0xbb && it->c2 == 0xb0) return 1;
		if(it->c1 == 0xbe && it->c2 == 0xe5) return 1;
		if(it->c1 == 0xc3 && it->c2 == 0xe6) return 1;
		if(it->c1 == 0xb2 && it->c2 == 0xbc) return 1;
		if(it->c1 == 0xb9 && it->c2 == 0xc3) return 1;
		if(it->c1 == 0xb2 && it->c2 == 0xb5) return 1;
		if(it->c1 == 0xca && it->c2 == 0xba) return 1;
		if(it->c1 == 0xc5 && it->c2 == 0xb7) return 1;
		/*
		if(it->c1 == 0xc3 && it->c2 == 0xcf) return 1;
		*/
		if(it->c1 == 0xbf && it->c2 == 0xcd) return 1; 

	}
	return 0;
}
static ITEXTR_T * _func2_1(ITEXTR_T *ch,ITEXT_T **it)
{
	ITEXTR_T *c;

	c = ch->next;
	if( _check_rev(c) == 0 ) return NULL;

	if( ! ChFlag((*it)->flag,_KUN) )
		OnFlag((*it)->flag,_KUN); 

	_k_in(&(*it)->kun_head,&(*it)->kun_tail,c);

	if( c->next == NULL) 
		return c;
	else
		c = c->next;
	
	while(1){

		if( _check_rev(c) == 0 ){
			if( c->c1 == AMARK && c->c2 == SHARP )
				c = c->prev;
			break;
		}

		_k_in(&(*it)->kun_head,&(*it)->kun_tail,c);


		if( c->next == NULL ) 
			break;
		else
			c = c->next;
	}

	return c;
}
static ITEXTR_T * _func2_2(ITEXTR_T *ch,ITEXT_T **it)
{
	ITEXTR_T *c;
	int i;

	c = ch->next;
	if( c->c1 != AMARK || c->c2 != SKAKO ) return NULL;

	i = 0;
	while(1){
		
		if( c->c1 == AMARK && c->c2 == EKAKO ) break;
		if( (c = c->next) == NULL ) break; 

		i++; 
	}

	if( c != NULL ){
		ITEXTR_T *c1;
		int j;

		c1 = ch->next;

		for( j = 0; j <= i; j++){

			_k_in(&(*it)->kun_head,&(*it)->kun_tail,c1);

			c1 = c1->next;
		}
		OnFlag((*it)->flag,_KUN); 

		return c;
	}else{

		return NULL;
	}
}
static int _func2_3(ITEXTR_T *ch)
{
	ITEXTR_T *c;

	if( ch == NULL ) return 0;
	c = ch->next;

	if( c->c1 == AMARK && c->c2 == SKAKO ) return 1;

	if( _check_rev(c) ) return 1;

	return 0;
}
static ITEXTR_T * _check_k(ITEXTR_T *ch,ITEXT_T **it)
{
	ITEXTR_T *c;

	if( (c = _func2_2(ch,it)) != NULL){

		return c->next;

	}
	if( (c = _func2_1(ch,it)) != NULL ){

		return c->next;

	}

	return ch;
}
unsigned char * checkRubyString(	ITEXT_T **ihead,
					ITEXT_T **itail,
					int *small,
					unsigned char *p	)
{
	ITEXTR_T *chu;
	unsigned char temp[BUFSIZ],c1,c2;
	int a,ok,kagi;

	static int no = 0;

	if(*itail == NULL) return p;


	memset(temp,0,BUFSIZ);

	a = ok = kagi = 0; 
	chu = (*itail)->chu_head;

	while( chu != NULL ){

		c1 = chu->c1; c2 = chu->c2;

		if( kagi == 1 && c1 == AMARK && c2 == EKAGI ) kagi = 0; 

		if( c1 == AMARK && c2 == SHARP){
			ok = 1;

			if( chu->next->c1 == AMARK && chu->next->c2 == SKAGI ) kagi = 1;

			if( kagi == 0 ){

				chu = _check_k(chu,itail);


				if( chu == NULL ) break;
				if( chu->c1 == AMARK && chu->c2 == SHARP ){

					if( _func2_3(chu) ) ok = 0;
				}

			}
		}


		if( ok ){
			if( c2 ){
				temp[a++] = c1; 
				temp[a++] = c2;
			}else{
				temp[a++] = c1;
			}
		}

		if( ok )
			if( (chu = chu->next) == NULL ) break;
	}
	
	if(a == 0) return p;

	temp[a] = '\0';
	/*
	fprintf(stderr,"%d %s@\n",no++,temp);
	*/

	if( _put_bousen_type((char *)temp,*itail) ) 
		return p;

	if( _put_small_font((char *)temp,*itail,small) )
		return p; 

	if(  _put_position((char *)temp,ihead,itail,p) )
		return p; 

	if( _put_wchufont((char *)temp,ihead,itail) )
	       return p;	


	if( ((*itail)->chu_string = (char *)malloc(a + 2)) != NULL){

		memset((*itail)->chu_string,0,a + 2);
		strncpy((*itail)->chu_string,(char *)temp + 2,strlen((char*)temp + 2));

	}

	if( Pict_Str((char *)temp) || Pict_Str_E((char *)temp)){ 

		if( _get_pict(&(*itail)->pict_path,(char *)temp) > 0 )
			OnFlag((*itail)->flag,_PIC); 

	}


	return p;
/*
	}
	for(chu=(*itail)->chu_head;chu!=NULL;chu=chu->next){
		itextDataInsert(ihead,itail,chu->c1,chu->c2,1,1,*small);
	}
	return i;
	*/
}
int checkSmlStr(BLINE_T *bl,int lsize,iconv_t icon)
{
		BLINE_T *b;
		char buf[lsize + EUC_BUFFER];
		int i;

		for( b = bl->n,i = 0; b != NULL; b = b->n,i++ ){
				memset(buf,0,lsize + EUC_BUFFER);

				itextConvKanjiCode(icon,buf,b->p,b->l);

				if( Small_End_Str0(buf) ) break;

				if( i > 100 ) break;
		}

		if( bl == NULL ) return 1;

		return 0;
}
int falseSmlString(FILE *fp,int *sml,iconv_t icon)
{
	fpos_t pos;
	char buf[BUFSIZ],buf_euc[BUFSIZ + EUC_BUFFER];
	int i,len;

	fgetpos(fp,&pos);
	i = 0;
	while(fgets(buf,BUFSIZ,fp) != NULL){
		len = strlen(buf);

		itextConvKanjiCode(icon,buf_euc,buf,len);

		if( Small_End_Str0(buf_euc) ){

				fsetpos(fp,&pos);
				return 1;
		}
		if(i++ > 100){
				fprintf(stderr,"falseSmlString() Over!\n");
			   	break;
		}
	}

	fsetpos(fp,&pos);
	*sml = 0;

	return 0;
}
int falseRubyString(ITEXT_T **ihead,ITEXT_T **itail)
{
	ITEXTR_T *rb, *rubi_head;

	fprintf(stderr,"Oh! falseRubyString()!\n");

	if((rubi_head = (*itail)->rubi_head) == NULL) 
			return -1;

	itextDataInsert(ihead,itail,AMARK,SRUBY,1,0,0);

	for(rb=rubi_head;rb!=NULL;rb=rb->next){

		itextDataInsert(ihead,itail,rb->c1,rb->c2,1,0,0);

	}

	return 0;
}
