/********************************
 * 2005/06/01  Ver2.8.0
 * 2010/02/01  Ver2.8.5
 * 2010/03/01  Ver2.9.0
 * *****************************/

#define XJP_MES	1
#define XJP_ICONV 1

#include "itext.h"
#include "xtext.h"
#include "xjp.h"
#include "xtext_1.h"

#include <locale.h>
#include <pthread.h>


Display *disp = NULL;
my_window_t *main_win = NULL;

page_data_t *char_p = NULL; 
char_data_t *char_d = NULL;

ICONTENT_T *main_book = NULL;

myorg_t *myorg = NULL;
mychu_t *mychu = NULL;

xtext_conf_t xconf;
xtext_net_t xnet;
offset_t xoffset;


static pthread_t pth;
static Window root;
static IBOOK_T *save_book_head = NULL, *save_book_tail = NULL;
static ISIORI_T *siori_head = NULL, *siori_tail = NULL;
static page_data_t *find_p = NULL;
static char StepBuf[STEP_MAX];
static int NPC = 0;

static void _set_pix();

void * xtextChuThreadWindow(void *);
void * xtextOrgThreadFunc(void *);

static void _x_init()
{
	setlocale(LC_ALL,"ja_JP.EUC-JP");

	if((XJP_CONV = iconv_open("UTF-8","EUC-JP")) == NULL){
		fprintf(stderr,"Error: _xinit() (iconv())\n");
		exit(1);
	}
	SEIKEI_LEVEL = (char *)euc2utf8(XJP_CONV,XJP_MESSAGE[6],strlen(XJP_MESSAGE[6]));
	if((disp = XOpenDisplay(NULL)) == NULL){
		fprintf(stderr,"Error: _x_init() (open_display)\n");
		exit(1);
	}
	if((main_win = (my_window_t *)malloc(sizeof(my_window_t))) == NULL){
		fprintf(stderr,"Error: _x_init() (my_window(malloc))\n");
		exit(1);
	}
	if((char_d = (char_data_t *)char_data_alloc()) == NULL){
		fprintf(stderr,"Error: _x_init() (char_d(malloc))\n");
		exit(1);
	}

	main_win->root = root = DefaultRootWindow(disp);
	main_win->cmap = DefaultColormap(disp,0);
	main_win->visual = DefaultVisual(disp,0);
	main_win->gc = XCreateGC(disp,root,0,0);
	main_win->bgc = XCreateGC(disp,root,0,0);
	main_win->fgc = XCreateGC(disp,root,0,0);
	main_win->rfgc = XCreateGC(disp,root,0,0);
	main_win->find_gc = XCreateGC(disp,root,0,0);
	main_win->rubi_gc = XCreateGC(disp,root,0,0);
	main_win->sgc = XCreateGC(disp,root,0,0);
	main_win->black_gc = XCreateGC(disp,root,0,0);
	main_win->image.img = 0;
	
#if HAVE_LIBXFT
	main_win->font = NULL;
	main_win->font_e = NULL;
	main_win->font_s = NULL;
	main_win->font_rubi = NULL;
	main_win->font_chu = NULL;
#endif

	XSetLineAttributes(disp,main_win->sgc,1,LineSolid,CapButt,JoinMiter);
	XSetErrorHandler((XErrorHandler)xjp_error);

	return;
}
static void _set_title()
{
	char temp[128];

	if( main_win->win ){
	/*
	XTextProperty ct
	XmbTextListToTextProperty(disp,&str,1,XCompoundTextStyle,&ct);
	XSetWMName(disp,win,&ct);
	*/
		sprintf(temp,"%s  [Ver.%s] ",XTEXT_NAME,XTEXT_VERSION);
		XStoreName(disp,main_win->win,temp);
	}

}
static void _set_win()
{
	if( main_win->win ){
		XSetWindowBackground(disp,main_win->win,main_win->bg_pixel);
		XClearWindow(disp,main_win->win);
	}
}
static void _x_end()
{
	if(char_d != NULL) char_data_free(char_d);
	if(XJP_CONV != NULL) iconv_close(XJP_CONV);

#if HAVE_LIBXFT
	if(main_win->draw != NULL) XftDrawDestroy(main_win->draw);
#endif

	if(main_win->pix0) XFreePixmap(disp,main_win->pix0);
	if(main_win->pix1) XFreePixmap(disp,main_win->pix1);
	if(main_win->win) XDestroyWindow(disp,main_win->win);

	if(main_win != NULL) free(main_win);
	if(disp != NULL) XCloseDisplay(disp);
}
static void _x_drawable()
{
	/*
	XSetWindowAttributes att;
	*/
	Atom a1;
	/*
	char temp[128];
	*/
	int w,h;

	w = main_win->width = xconf.main_window_width;
	h = main_win->height = xconf.main_window_height;

	if( !(main_win->win = XCreateSimpleWindow(disp,root,0,0,w,h,0,0,0)) ){
		fprintf(stderr,"Error: xtext_main.c(Create Window)\n");
		exit(1);
	}

	XSelectInput(disp,main_win->win,ExposureMask|StructureNotifyMask|ButtonPressMask|KeyPressMask);

	a1 = XInternAtom(disp,"WM_DELETE_WINDOW",False);
	XSetWMProtocols(disp,main_win->win,&a1,1);

	XMapWindow(disp,main_win->win);

	_set_title();
	_set_pix();

#if HAVE_LIBXFT
	main_win->draw = XftDrawCreate(disp,main_win->pix0,main_win->visual,main_win->cmap);
/*
	main_win->draw = XftDrawCreate(disp,main_win->win,main_win->visual,main_win->cmap);
	*/
#endif

	return;
}
static void _set_col()
{
	XColor c1,c0;

	XAllocNamedColor(disp,main_win->cmap,xconf.main_font_color,&c1,&c0);
	XSetForeground(disp,main_win->gc,c1.pixel);
	XSetBackground(disp,main_win->bgc,c1.pixel);
	main_win->fg_pixel = c1.pixel;

	XAllocNamedColor(disp,main_win->cmap,xconf.main_window_color,&c1,&c0);
	XSetForeground(disp,main_win->bgc,c1.pixel);
	XSetBackground(disp,main_win->gc,c1.pixel);
	main_win->bg_pixel = c1.pixel;

	XAllocNamedColor(disp,main_win->cmap,xconf.menu_font_color,&c1,&c0);
	XSetForeground(disp,main_win->fgc,c1.pixel);
	XSetBackground(disp,main_win->rfgc,c1.pixel);
	main_win->menu_fg_pixel = c1.pixel;

	XAllocNamedColor(disp,main_win->cmap,xconf.menu_window_color,&c1,&c0);
	XSetForeground(disp,main_win->rfgc,c1.pixel);
	XSetBackground(disp,main_win->fgc,c1.pixel);
	main_win->menu_bg_pixel = c1.pixel;

	XAllocNamedColor(disp,main_win->cmap,xconf.rubi_font_color,&c1,&c0);
	XSetForeground(disp,main_win->rubi_gc,c1.pixel);
	main_win->rubi_fg_pixel = c1.pixel;


	XAllocNamedColor(disp,main_win->cmap,xconf.pointer_fg_color,&c1,&c0);
	main_win->pointer_fg_pixel = c1.pixel;

	XAllocNamedColor(disp,main_win->cmap,xconf.main_shadow_color,&c1,&c0);
	main_win->rubi_bg_pixel = c1.pixel;

	XAllocNamedColor(disp,main_win->cmap,xconf.main_shadow_color,&c1,&c0);
	XSetForeground(disp,main_win->sgc,c1.pixel);

	XAllocNamedColor(disp,main_win->cmap,xconf.find_font_color,&c1,&c0);
	XSetForeground(disp,main_win->find_gc,c1.pixel);

	if(xconf.anti){

#if HAVE_LIBXFT
	long xjp_alpha = 0xFFFF;

	XftColorAllocName(disp,main_win->visual,main_win->cmap,xconf.main_window_color,&(main_win->bg_color));
	/*
	main_win->bg_color.color.alpha = xjp_alpha;
	*/
	XftColorAllocName(disp,main_win->visual,main_win->cmap,xconf.main_font_color,&(main_win->fg_color));
	main_win->fg_color.color.alpha = xjp_alpha;

	XftColorAllocName(disp,main_win->visual,main_win->cmap,xconf.rubi_font_color,&(main_win->rubi_color));
	main_win->rubi_color.color.alpha = xjp_alpha;

	XftColorAllocName(disp,main_win->visual,main_win->cmap,xconf.menu_font_color,&(main_win->menu_fg_color));
	main_win->menu_fg_color.color.alpha = xjp_alpha;

	XftColorAllocName(disp,main_win->visual,main_win->cmap,xconf.menu_window_color,&(main_win->menu_bg_color));
	main_win->menu_bg_color.color.alpha = xjp_alpha;

	XftColorAllocName(disp,main_win->visual,main_win->cmap,xconf.find_font_color,&(main_win->find_color));
	main_win->find_color.color.alpha = xjp_alpha;

	XftColorAllocName(disp,main_win->visual,main_win->cmap,xconf.main_shadow_color,&(main_win->s_color));
	main_win->s_color.color.alpha = xjp_alpha;

#endif

	}
	SELECTOR_BACKGROUND_COLOR = (char *)xconf.select_window_color;
	SELECTOR_FOREGROUND_COLOR = (char *)xconf.select_font_color;
	SELECTOR_SELECTFONT_COLOR = (char *)xconf.select_font_background_color;
}
static void _set_normal_font()
{
	char *chu_font = "-*-fixed-*-*-*--14-*-*-*-*-*-jisx0208.1990-*";
	char xjp_fontset[1024];
	char **miss,*def;
	int n_miss;

	xtext_create_fontset(xconf.main_font_j,xjp_fontset,1024,"18");
	if((main_win->fs = XCreateFontSet(disp,xjp_fontset,&miss,&n_miss,&def)) == NULL){
			fprintf(stderr,"Error: (font)_set_fnt() (main_fs)\n");
			exit(1);
	}

	xtext_create_fontset(xconf.main_font_e,xjp_fontset,1024,"18");
	if((main_win->fs_e = XCreateFontSet(disp,xjp_fontset,&miss,&n_miss,&def)) == NULL){
			fprintf(stderr,"Error: (font)_set_fnt() (main_fs_e)\n");

			exit(1);
	}

	xtext_create_fontset(xconf.main_font_s,xjp_fontset,1024,"16");
	if((main_win->fs_s = XCreateFontSet(disp,xjp_fontset,&miss,&n_miss,&def)) == NULL){
			fprintf(stderr,"Error: (font) _set_fnt() (main_fs_s)\n");

			exit(1);
	}


	xtext_create_fontset(xconf.rubi_font,xjp_fontset,1024,"14");
	if((main_win->rubi_fs = XCreateFontSet(disp,xjp_fontset,&miss,&n_miss,&def)) == NULL){
				fprintf(stderr,"Error: (font) _set_fnt() (main_fs_rubi)\n");

				exit(1);
	}
	xtext_create_fontset(chu_font,xjp_fontset,1024,"14");
	if((main_win->chu_fs = XCreateFontSet(disp,xjp_fontset,&miss,&n_miss,&def)) == NULL){
				fprintf(stderr,"Error: (font) _set_fnt() (main_fs_chu)\n");

				exit(1);
	}
	return;
}
#if HAVE_LIBXFT
static void _set_anti_font()
{
	char *xjp_font = "-*-*-*-*-*--18-*-*-*-*-*-*-*";
	char *xjp_font_c = "-*-*-*-*-*--14-*-*-*-*-*-*-*";
	char *xjp_font_r = "-*-*-*-*-*--12-*-*-*-*-*-*-*";
	char font_str[1024];

	if(main_win->font != NULL) 
		XftFontClose(disp,main_win->font);

	if(main_win->font_e != NULL) 
		XftFontClose(disp,main_win->font_e);

	if(main_win->font_s != NULL) 
		XftFontClose(disp,main_win->font_s);

	if(main_win->font_rubi != NULL) 
		XftFontClose(disp,main_win->font_rubi);

	euc2utf8_c(XJP_CONV,font_str,xconf.main_font_j,strlen(xconf.main_font_j));
	if( (main_win->font = XftFontOpenXlfd(disp,0,font_str))  == NULL ){

		euc2utf8_c(XJP_CONV,font_str,xjp_font,strlen(xjp_font));
		if( (main_win->font = XftFontOpenXlfd(disp,0,font_str))  == NULL ){

			fprintf(stderr,"Error: (font)_set_fnt() (main_fs xft)\n");
			exit(1);
		}
	}

	euc2utf8_c(XJP_CONV,font_str,xconf.main_font_e,strlen(xconf.main_font_e));
	if((main_win->font_e = XftFontOpenXlfd(disp,0,font_str)) == NULL){

		euc2utf8_c(XJP_CONV,font_str,xjp_font,strlen(xjp_font));
		if( (main_win->font_e = XftFontOpenXlfd(disp,0,font_str))  == NULL ){
			fprintf(stderr,"Error: (font)_set_fnt() (main_fs_e xft)\n");
			exit(1);
		}
	}

	euc2utf8_c(XJP_CONV,font_str,xconf.main_font_s,strlen(xconf.main_font_s));
	if((main_win->font_s = XftFontOpenXlfd(disp,0,font_str)) == NULL){

		euc2utf8_c(XJP_CONV,font_str,xjp_font,strlen(xjp_font));
		if( (main_win->font_s = XftFontOpenXlfd(disp,0,font_str))  == NULL ){

			fprintf(stderr,"Error: (font)_set_fnt() (main_fs_s xft)\n");
			exit(1);
		}
	}

	euc2utf8_c(XJP_CONV,font_str,xconf.rubi_font,strlen(xconf.rubi_font));
	if((main_win->font_rubi = XftFontOpenXlfd(disp,0,font_str)) == NULL){

		euc2utf8_c(XJP_CONV,font_str,xjp_font_r,strlen(xjp_font_r));
		if( (main_win->font_rubi = XftFontOpenXlfd(disp,0,font_str))  == NULL ){

			fprintf(stderr,"Error: (font)_set_fnt() (main_fs_rubi xft)\n");
			exit(1);
		}
	}

	euc2utf8_c(XJP_CONV,font_str,xjp_font_c,strlen(xjp_font_c));
	if( (main_win->font_chu = XftFontOpenXlfd(disp,0,font_str))  == NULL ){

		fprintf(stderr,"Error: (font)_set_fnt() (main_fs_rubi xft)\n");
		exit(1);
	}


	return;
}
#endif
static void _set_fnt()
{

	if(xconf.anti){

#if HAVE_LIBXFT
		_set_anti_font();
#else
		_set_normal_font();
#endif

	}else{
		_set_normal_font();
	}

	main_win->change_font = 1;
	SELECTOR_FONT_NAME = (char *)xconf.main_font_j;

	return;
}
static void _set_utl()
{
	main_win->title_on = xconf.title_on;
	main_win->anti = xconf.anti;
	main_win->kinsc = xconf.kinsc;
	main_win->page_on = xconf.page_on;
	main_win->cursor = xconf.cursor;

	main_win->spf0 = xconf.page_feed0;
	main_win->spf1 = xconf.page_feed1;
	main_win->spl = xconf.page_speed;
	main_win->rev = xconf.page_reverse;

	return;
}
static void _set_chr()
{
	char_d->xpad = xconf.line_space != -1 ? xconf.line_space:0;
	char_d->ypad = xconf.row_space != -1 ? xconf.row_space:0;
}
static void _set_pix()
{
	GC g;
	int w,h;

	g = main_win->bgc;
	w = main_win->width;
	h = main_win->height;

	main_win->pix0 = XCreatePixmap(disp,root,w,h,DefaultDepth(disp,0));
	main_win->pix1 = XCreatePixmap(disp,root,w,h,DefaultDepth(disp,0));

	XFillRectangle(disp,main_win->pix0,g,0,0,w,h);
	XFillRectangle(disp,main_win->pix1,g,0,0,w,h);
	/*
	if(xconf.main_window_img != NULL){
		if(main_win.image.img != 0) XFreePixmap(disp,main_win.image.img);
		xtextGetImage(disp,&main_win,xconf.main_window_img);
	}
	*/
	return;
}
/*
static void _set_net()
{
	xnet.book_dir = xconf.book_dir; 
	xnet.ao_url = xconf.ao_url; 
	xnet.ao_list = xconf.ao_list;

	return;
}
*/
static void _set_cursor()
{
	 main_win->pointer1 = xtextGetFontCursor(disp,main_win,C_TITLE); 

	return;
}
static void _set_myorg()
{
	if( myorg != NULL ) free(myorg);

	if ( mychu != NULL ) {
		chum_t *c,*cc;
		if( mychu->ch != NULL ){
			for( c = mychu->ch; c != NULL; c = cc ){
				cc = c->next;
				free(c);
			}
		}
		free(mychu);
	}

	if( (myorg = (myorg_t *)malloc(sizeof(myorg_t))) != NULL){

		myorg->m = main_win;
		myorg->s_no = 0;
		myorg->e_no = 0;
		myorg->bh = NULL;
	}

	if( (mychu = (mychu_t *)malloc(sizeof(mychu_t))) != NULL){
		mychu->m = main_win;
		mychu->ch = NULL;
	}
}
static void _set_xconf_data()
{
	_set_utl();
	_set_col();
	_set_win();
	_set_fnt();
	_set_chr();
	_set_cursor();
	_set_myorg();

	return ;
}
static int _quit_win()
{
	sub_window_t *q_head = NULL, *q_tail = NULL;

	char *result;

	xtextQuitData2Sub(&q_head,&q_tail,&xconf);

	if((result = (char *)xtextSubWindow(disp,main_win,q_head,q_tail,60,1)) == NULL) 
		return -1;


	if(strcmp(result,XJP_OK) == 0) return 0;

	return 1;
}
static int _configure_win(XEvent ev)
{

	if(	main_win->width != ev.xconfigure.width 		|| 
		main_win->height != ev.xconfigure.height	){

		main_win->width = xconf.main_window_width = ev.xconfigure.width;
		main_win->height = xconf.main_window_height = ev.xconfigure.height;

		if( main_win->pix0 ){ 
			XFreePixmap(disp,main_win->pix0);
			XFreePixmap(disp,main_win->pix1);
			_set_pix();

#if HAVE_LIBXFT
			XftDrawChange(main_win->draw,main_win->pix0);
#endif 

		}
		char_p = (page_data_t *)xtext_Redraw_Text(disp,main_win,main_book,char_d,NPC);
		return 1;

	}

	return 0;
}
static int _siori_win()
{
	if(siori_head == NULL)
		xtextSubWindow_Message(disp,main_win,XJP_MESSAGE[2]);
	else
		select_siori_data(siori_head,0);

	return 1;
}
static int _bookmark_win()
{
	if(char_d->book == NULL) return 1;

   	if(xtext_siori_data_mark(&siori_head,&siori_tail,char_d->book->book_path,char_d->book->book_title,NPC) < 0) return -1;

	xtext_siori_data_write(&siori_head,&siori_tail);

	xtextSubWindow_Message(disp,main_win,XJP_MESSAGE[0]);

	return 1;
}
static  page_data_t * _page_find(page_data_t *find)
{
	page_data_t *pt;
	int start,end;

	if(find == NULL) return char_p; 

	for(pt=char_d->head;pt!=NULL;pt=pt->next){
		start = pt->char_no;

		if(pt->next != NULL)
			end = pt->next->char_no;
		else
			end = -1;

		if(end > 0){
			if(find->char_no >= start && find->char_no < end) 
				return pt;
		}else{
			if(find->char_no >= start) 
				return pt;
		}
	}

	return NULL;
}
static  page_data_t * _page_step(page_data_t *page,int step)
{
	page_data_t *p,*pp;
	int i = 0;

	if(step == 0) return page;
	if(page == NULL) return NULL;

	if(step > 0){
		for(p=page,i=0;p!=NULL;p=p->next,i++){
			if(i == step) return p;
			pp = p;
		}
	}else{
		for(p=page,i=0;p!=NULL;p=p->prev,i--){
			if(i == step) return p;
			pp = p;
		}
	}
	return pp;
}
static int _next_win(int step)
{
	if(main_book->b_head == NULL || char_p->next == NULL) 
		return -1;


	if(step == 0) step = 1;

	char_p = _page_step(char_p,step);

	return 1;
}
static int _prev_win(int step)
{
	if(main_book->b_head == NULL || char_p->prev == NULL) 
		return -1;


	if(step == 0) step = -1;

	char_p = _page_step(char_p,step);

	return 1;
}
static int _next_find_win()
{
	int find_page;

	if(find_p == NULL || find_p->next == NULL) 
		return -1;

	find_page = char_p->page_no;
	while(1){

		if(find_p->next == NULL) break;
		find_p = find_p->next;
		if((char_p = _page_find(find_p))->page_no != find_page) break;

	}

	return 1;
}
static int _prev_find_win()
{
	int find_page;

	if(find_p == NULL || find_p->prev == NULL) 
		return -1;

	find_page = char_p->page_no;
	while(1){
		if(find_p->prev == NULL) break;
		find_p = find_p->prev;
		if((char_p = _page_find(find_p))->page_no != find_page) break;
	}

	return 1;
}
static int _title_key_win()
{
	xconf.title_on = xconf.title_on ? 0 : 1;

	if(xconf.title_on == 0) xconf.cursor = 2;

	_set_utl();

	char_p = (page_data_t *)xtext_Redraw_Text(disp,main_win,main_book,char_d,NPC);

	return 1;
}
static int _page_key_win()
{
	xconf.page_on = xconf.page_on ? 0 : 1;

	_set_utl();

	return 1;
}
static int _kinsc_win()
{
	if(xconf.kinsc++ >= 2) xconf.kinsc = 0;

	_set_utl();

	char_p = (page_data_t *)xtext_Redraw_Text(disp,main_win,main_book,char_d,NPC);

	return 1;
}
static int _curs_win()
{
	if(xconf.cursor++ >= 4) xconf.cursor = 0;

	_set_utl();

	return 1;
}
static int _chuki_win()
{
	chum_t *c,*ct,*cts = NULL;

	if( char_d->chead == NULL ) return 1;

	if( mychu->ch != NULL )
	       chu_data_free(mychu->ch);	

	mychu->ch = NULL;

	for( c = char_d->chead; c != NULL; c = c->next ){

		ct = (chum_t *)malloc(sizeof(chum_t));
		ct->s = c->s;
		ct->n = c->n;
		ct->next = NULL;

		if( mychu->ch == NULL ){
			mychu->ch = ct;
		}else{
			cts->next = ct;
		}
		cts = ct;
	}

	mychu->m = main_win;

	if( main_win->anti ){
#if HAVE_LIBXFT
		euc2utf8_c(XJP_CONV,mychu->f,xconf.chuki_font,strlen(xconf.chuki_font));
#else
		xtext_create_fontset(xconf.chuki_font,mychu->f,512,"16");
#endif
	}else{
		xtext_create_fontset(xconf.chuki_font,mychu->f,512,"16");
	}

	if( pthread_create(&pth,NULL,xtextChuThreadFunc,mychu) != 0 )
		fprintf(stderr,"Error: thread_create(chuki_win)\n");

	return 1;
}
static int _org_win()
{

	if( char_p == NULL ) return 1;


	myorg->s_no = char_p->buff_no - 1;

	if( char_p->next != NULL )
		myorg->e_no = char_p->next->buff_no;
	else
		myorg->e_no = -1;

	myorg->bh = main_book->b_head;
	myorg->m = main_win;

	if( main_win->anti ){
#if HAVE_LIBXFT
		euc2utf8_c(XJP_CONV,myorg->f,xconf.org_font,strlen(xconf.org_font));
#else
		xtext_create_fontset(xconf.org_font,myorg->f,512,"16");
#endif
	}else{
		xtext_create_fontset(xconf.org_font,myorg->f,512,"16");
	}

	if( pthread_create(&pth,NULL,xtextOrgThreadFunc,myorg) != 0 )
		fprintf(stderr,"Error: thread_create(chuki_win)\n");

	return 1;
}
static int _find_win()
{
	xtextCheckFindData(main_book,char_d,xtextInputWindow(disp,main_win,NULL,NULL,60));

	find_p = char_d->find_head;
	char_p = _page_find(find_p);

	return 1;
}
static int _rast_win()
{
#if HAVE_ATEXIT
	rast_win_reg(save_book_head);
#endif
	return 1;
}
static int help_book_data()
{
	sub_window_t *help_head = NULL, *help_tail = NULL;
	char *result; 
	int percent = 95;

	xtextHelpData2Sub(&help_head,&help_tail,&xconf);

	if((result = xtextSubWindow(disp,main_win,help_head,help_tail,percent,0))==NULL) 
		return -1;

	if(strcmp(result,XJP_OK) == 0) 
		return 1; 

	return 0;
}
static int _conf_win()
{
	if(help_book_data()){
		_set_xconf_data(); 
		char_p = (page_data_t *)xtext_Redraw_Text(disp,main_win,main_book,char_d,NPC);
	}

	return 1;
}
int config_win(void *data0,int data1)
{
	if(help_book_data()){
		_set_xconf_data(); 
		char_p = (page_data_t *)xtext_Redraw_Text(disp,main_win,main_book,char_d,NPC);
		return 1;
	}

	return 0;
}
int menu_win(void *data0,int data1)
{
	int ret;

	if(save_book_head != NULL)
		book_link_free(&save_book_head,&save_book_tail);

	if(xconf.book_dir == NULL){
		xtextSubWindow_Message(disp,main_win,XJP_MESSAGE[1]); 
		return 1; 
	}

	save_book_head = NULL; save_book_tail = NULL;

	ret = ibookGetBookData(&save_book_head,&save_book_tail,xconf.book_dir);
	if( ret == 0 ){
		xtextSubWindow_Message(disp,main_win,XJP_MESSAGE[23]);

	}else if( ret == -1){
		xtextSubWindow_Message(disp,main_win,XJP_MESSAGE[1]);
	}

	if(save_book_head == NULL) return 1;

	save_book_head->siori = siori_head;
	save_book_head->dbpath = xconf.rast_db;
	save_book_head->bookdir = xconf.book_dir;

	if(select_book_data(save_book_head,0) < 0) 

		menu_win(data0,data1);

	return 1;
}
static void _draw_caption()
{

	if((NPC = xtext_Draw_Text(disp,main_win,main_book,char_d,char_p)) < 0)
		xtext_func(disp,main_win,&xconf);

	return;
}
static int _expose_win(int type)
{
	int height,width;

	if( type != 0 && type != 1 && type != 2 ){
			fprintf(stderr,"Error: _expose_win() type_no = %d\n",type);
			return 1;
	}

	height = main_win->height;
	width = main_win->width;

	if( type && main_win->spl ){
		int w, w0;
		int x = 0, y = 0;
		int x0,start = 0,end = 0;

		if( main_win->rev ){

			if( type == 1 ) 
				type = 2;

			else if( type == 2 ) 
				type = 1;
		}

		w = main_win->spf1; w0 = main_win->spf0;

		switch(type){
			case 1 :
				x = 0;
				start = 0;
				end = width;
			break;
			case 2 :
				x = width;
				start = width;
				end = 0;
			break;
		}

		x0 = start;
		while(1){
			if( (type == 1  && x <= (end - w)) 	||
			    (type == 2  && x >= (end - w))	){

				XClearArea(	disp,
						main_win->win,
						x,
						y,
						w,
						height,
						False			
					   );
			}
			XCopyArea(	disp,
					main_win->pix0,
					main_win->win,
					main_win->gc,
					x0,
					y,
					w0,
					height,
					x0,
					y			);

			XSync(disp,0);
			usleep(main_win->spl);

			if(type == 2){

				if( (x0 -= w0) <= 0 ) break;
				x -= w;

			}else if(type == 1){

				if( (x0 += w0) >= width ) break;
				x += w;

			}	

		}

	}

	XCopyArea(	disp,
			main_win->pix0,
			main_win->win,
			main_win->gc,
			0,
			0,
			width,
			height,
			0,
			0			);


	return 1;
}
static int _xtext_main_event(XEvent ev)
{
	char *keyname;
	int re = 1,type = 0;

	switch(ev.type){

		case Expose:
			_expose_win(type);
		break;

		case ConfigureNotify:
			if( _configure_win(ev) )
				_draw_caption();

			_expose_win(type);
		break;

		case ButtonPress:
			if(ev.xbutton.button == 1){
				_next_win(1);
				type = 1;

			}else if(ev.xbutton.button == 2){
				menu_win(NULL,0);
				type = 0;

			}else if(ev.xbutton.button == 3){
				_prev_win(-1);
				type = 2;
			}
			_draw_caption();
			_expose_win(type);
		break;

		case KeyPress:
			keyname = (char *)XKeysymToString(XLookupKeysym(&ev.xkey,0)); 
			type = 0;

			if( func17_0(keyname) ){
				char *p;

				for( p = StepBuf; *p; p++ ){
				}
				*p = *(keyname + 0);

				break;
			}

			if( ev.xkey.keycode == xconf.page_next_key ){
				_next_win(atoi(StepBuf));
				type = 1;

			}else if( ev.xkey.keycode == xconf.page_prev_key ){
				_prev_win(atoi(StepBuf) * -1);
				type = 2;

			}else if( ev.xkey.keycode == xconf.menu_code_key ){
				menu_win(NULL,0);

			}else if( ev.xkey.keycode == xconf.conf_page_key ){
				_conf_win();

			}else if( ev.xkey.keycode == xconf.book_mark_key ){
				_bookmark_win();

			}else if( ev.xkey.keycode == xconf.siori_menu_key ){
				_siori_win();

			}else if( ev.xkey.keycode == xconf.quit_code_key ){
				re = _quit_win();

			}else if( ev.xkey.keycode == xconf.title_code_key ){
				_title_key_win();

			}else if( ev.xkey.keycode == xconf.page_code_key ){
				_page_key_win();

			}else if( ev.xkey.keycode == xconf.kinsc_code_key ){
				_kinsc_win();

			}else if( ev.xkey.keycode == xconf.chuki_code_key ){
				_chuki_win();

			}else if( ev.xkey.keycode == xconf.org_code_key ){
				_org_win();

			}else if( ev.xkey.keycode == xconf.cursor_code_key ){
				_curs_win();

			}else if( ev.xkey.keycode == xconf.other_code_key ){
				other_win(main_book,&xconf);

			}else if( ev.xkey.keycode == xconf.net_code_key ){
#if HAVE_NETDB_H
				net_win(NULL,0);
#endif
			}else if( ev.xkey.keycode == xconf.find_code_key ){
				_find_win();

			}else if( ev.xkey.keycode == xconf.find_next_key ){
				_next_find_win();

			}else if( ev.xkey.keycode == xconf.find_prev_key ){
				_prev_find_win();

			}else if( ev.xkey.keycode == xconf.rast_code_key ){
				_rast_win();

			}else{
				return 1;
			}

			_draw_caption();
			_expose_win(type);
			memset(StepBuf,0,STEP_MAX);

		break;
	}


	return re;
}
int main(int argc,char *argv[])
{
	XEvent ev;

	char *opt_book_path = NULL; 
	char *xjp_help = NULL; 
	int loop = 1;

	if((main_book = (ICONTENT_T *)content_link_alloc()) == NULL){
		fprintf(stderr,"Error: content_link_alloc() xtext_main.c(941)\n");
		 exit(1);
	}

	_x_init(); 

	xjp_help = (char *)xtext_conf_data(disp,&xconf);

	xtext_offt_data(&xoffset.main_off_head,&xoffset.main_off_tail,OFFSET_FILE_MAIN);
	xtext_offt_data(&xoffset.sub_off_head,&xoffset.sub_off_tail,OFFSET_FILE_SUB);

	xtext_siori_data_read(&siori_head,&siori_tail);

	/*
	opt_book_path = (char *)xtext_get_option(argc,argv,&xconf);
	*/
	/*
	xjp_xconf(&xconf);
	*/

	_x_drawable(); 
	_set_xconf_data();

	if(opt_book_path != NULL){ 

		char_p = (page_data_t *)xtext_Init_Book(disp,main_win,main_book,char_d,&xoffset,&xconf,opt_book_path,0);

	}

	_draw_caption();


	while(loop){

		XNextEvent(disp,&ev);

		loop = _xtext_main_event(ev);

		xtextCursorType(disp,main_win,xjp_help,main_book->titlename);
	}

	xtext_siori_data_write(&siori_head,&siori_tail);

	_x_end();

	return 0;
}

